/******************************************************************************/
/*!
\file		Worker.h
\project	Icarus Engine
\author		Jorge Antonio Jimenez

/brief		Generates a single Thread, and keeps track of the activity
			that the thread is executing.
*/
/******************************************************************************/
#pragma once

#include <memory>
#include <thread>

#include <Engine\MultiThread\IJob.h>

namespace IcarusEngine
{
	// Forward Declaration
	class Worker;

	void GetandExecuteJob(Worker* worker = nullptr);

	class Worker
	{
		public:
			Worker();
			~Worker();

			void StartUp(unsigned int index);

			void ShutDown();

			void SetJob(JobPtr job);

			JobPtr GetJob();

			bool IsActive();

			void SetStatus(bool status);

			unsigned int GetWorkerId();

		private:
			bool m_Active;
			unsigned int m_WorkerId;
			JobPtr m_CurrentJob;
			std::thread * m_workerthread;
	};
}