#include <Engine\SystemJob.h>

namespace IcarusEngine
{

	SystemJob::SystemJob(ISystem * system, float dt)
		: m_System(system),
		m_Timeslice(dt)
	{
		m_Priority = JobPriority::High;
		if(!m_System)
		{
			m_Status = JobStatus::Canceled;
		}
	}

	void SystemJob::Execute()
	{
		m_System->Update(m_Timeslice);
	}

	std::string SystemJob::GetName()
	{
		return m_System->GetName();
	}
}